/*
 * Trade.java
 *
 * Class to abstract an Apama trade event used by the VWAP application.
 * A trade event gives the symbol or name of the stock being traded, the 
 * price at which the stock was traded, and the volume of stock traded
 *
 * $Copyright(c) 2002,  2004 - 2006 Progress Software Corporation. All Rights Reserved.$ 
 * $Copyright (c) 2013,2019 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.$ 
 * Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG 
 *
 * $Revision: 359265 $
 */

import com.apama.jmon.Event;


public class Trade extends Event {
	private static final long serialVersionUID = 21L;
    /** The symbol of the stock */
    public String stockName;
    
    /** The price at which the stock was traded */
    public double price;
    
    /** The number of stocks traded */
    public double volume;
    

    /**
     * No argument constructor
     */    
    public Trade() {
	this("", 0, 0);
    }
    

    /**
     * Construct a Trade object and set the instance variables
     * 
     * @param  stockName       The symbol of the stock
     * @param  price           The price at which the stock was traded
     * @param  volume          The number of stocks traded 
     */
    public Trade(String stockName, double price, double volume){
	this.stockName = stockName;
	this.price = price;
	this.volume = volume;
    }
}

